//+------------------------------------------------------------------+
//|                                                Combo_Right-4.mq5 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                  Combo_Right.mq5 |
//|                                          Copyright 2012, Integer |
//|                          https://login.mql5.com/ru/users/Integer |
//|,    
//|  Exp_StepSto_v1      
// StepSto_v1.        
// .        
// ,   .    
//  50,         
//,     50,      
// .       
//   ,    
// .

//+------------------------------------------------------------------+
#property copyright "Integer"
#property link "https://login.mql5.com/ru/users/Integer"
#property description ""
#property version   "1.00"

#property description "   MQ4,  Reshetov (http://www.mql4.com/ru/users/Reshetov),    - http://codebase.mql4.com/ru/2719"

#include <Trade/Trade.mqh>
#include <Trade/SymbolInfo.mqh>
#include <Trade/PositionInfo.mqh>

CTrade Trade;
CSymbolInfo Sym;
CPositionInfo Pos;
   //+-----------------------------------------------+
//|             |
//+-----------------------------------------------+
input double MM=0.2;             //      ,   -  
input int    Deviation_=10;       //.    
input bool   BuyPosOpen=true;     //    
input bool   SellPosOpen=true;    //    
input bool   BuyPosClose=true;     //    
input bool   SellPosClose=true;    //    
input int      Trailing       =  70;             /*Trailing*/         //  ,   0  
input int      BreakEven      =  60;             /*BreakEven*/        //          .   0   

//+-----------------------------------------------+
//|     StepSto_v1   |
//+-----------------------------------------------+
input ENUM_TIMEFRAMES InpInd_Timeframe=PERIOD_M15; // 
input uint SignalBar=1;//     
//----
input double Kfast=1.0000;
input double Kslow=1.0000;
//+----------------------------------------------+
//----          
int TimeShiftSec;
//----      
int InpInd_Handle;
//----      
int min_rates_total;
//+------------------------------------------------------------------+
//                                                  | 
//+------------------------------------------------------------------+
#include <TradeAlgorithms.mqh>
//--- input parameters

input double                           tp1               =  260;              /*tp1*/           //        
input double                           sl1               =  800;              /*sl1*/           //        
input int                              CCIPeriod         =  21;	            /*CCIPeriod*/     //  CCI
input ENUM_APPLIED_PRICE               CCIPrice          =  PRICE_OPEN;	      /*CCIPrice*/      //  CCI

input int                              x12               =  9;              /*x12*/           //   
input int                              x22               =  22;
input int                              x32               =  21;
input int                              x42               =  22;
input double                           tp2               =  12;              /*tp2*/           //        
input double                           sl2               =  25;              /*sl2*/           //        
input int                              p2                =  20;               /*p2*/            //      

input int                              x13               =  80;              /*x13*/           //   
input int                              x23               =  143;
input int                              x33               =  344;
input int                              x43               =  70;
input double                           tp3               =  12;              /*tp3*/           //        
input double                           sl3               =  25;              /*sl3*/           //        
input int                              p3                =  20;               /*p3*/            //      

input int                              x14               =  31;              /*x14*/           //   
input int                              x24               =  17;
input int                              x34               =  60;
input int                              x44               =  36;
input int                              p4                =  85;               /*p4*/            //      

input int                              pass              =  4;                /*pass*/          //   : 1 -  , 1 -  , 2 -  , 4 -  ,  .
input double                           lots              =  1.0;
input int                              Shift             =  1;                /*Shift*/         //       : 0 -  , 1 -   

double w11;
double w12;
double w13;
double w14;

double w21;
double w22;
double w23;
double w24;

double w31;
double w32;
double w33;
double w34;

int sh11;
int sh12;
int sh13;
int sh14;
int sh15;

int sh21;
int sh22;
int sh23;
int sh24;
int sh25;

int sh31;
int sh32;
int sh33;
int sh34;
int sh35;

double output1;
double output2;
double output3;

int CCIHandle=INVALID_HANDLE;


int          prevtime = 0;
double       sl = 10;
double       tp = 10;

int Handle=INVALID_HANDLE;

datetime ctm[1];
datetime LastTime;
double lot,slv,msl,tpv,mtp;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit(){

   w11=x12-9;
   w12=x22-22;
   w13=x32-21;
   w14=x42-22;
      
   w21=x13-80;
   w22=x23-143;
   w23=x33-344;
   w24=x43-70;
      
   w31=x14-31;
   w32=x24-17;
   w33=x34-60;
   w34=x44-36;
   
   sh11=Shift;
   sh12=Shift+p2;
   sh13=Shift+p2*2;
   sh14=Shift+p2*3;
   sh15=Shift+p2*4;
   
   sh21=Shift;
   sh22=Shift+p3;
   sh23=Shift+p3*2;
   sh24=Shift+p3*3;
   sh25=Shift+p3*4;      
   
   sh31=Shift;
   sh32=Shift+p4;
   sh33=Shift+p4*2;
   sh34=Shift+p4*3;
   sh35=Shift+p4*4;     

   //  ...
   
   CCIHandle=iCCI(_Symbol,PERIOD_CURRENT,CCIPeriod,CCIPrice);

   if(CCIHandle==INVALID_HANDLE){
      Alert("  ,  ");
      return(-1);
   }   
   
   if(!Sym.Name(_Symbol)){
      Alert("  CSymbolInfo,  ");    
      return(-1);
   }

   Print("  ");
   //----    StepSto_v1
   InpInd_Handle=iCustom(Symbol(),InpInd_Timeframe,"StepSto_v1",Kfast,Kslow,0);
   if(InpInd_Handle==INVALID_HANDLE) Print("     StepSto_v1");

//----          
   TimeShiftSec=PeriodSeconds(InpInd_Timeframe);

//----     
   min_rates_total=int(MathMax(2,10));
   min_rates_total+=int(1+2+SignalBar);
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason){
   if(CCIHandle!=INVALID_HANDLE)IndicatorRelease(CCIHandle);
      GlobalVariableDel_(Symbol());

}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick(){

   if(CopyTime(_Symbol,PERIOD_CURRENT,0,1,ctm)==-1){
      return;
   }
   if(Shift==0 || ctm[0]!=LastTime){
      
      sl=sl1;
      tp=tp1;      
      
      // 
      double Signal;
      if(!Supervisor(Signal)){
         return;
      }
 
      // 
      if(!Pos.Select(_Symbol)){
            if(Signal>0){ 
               if(!Sym.RefreshRates())return;         
               if(!SolveLots(lot))return;
               slv=SolveBuySL(sl);
               tpv=SolveBuyTP(tp);
                  if(CheckBuySL(slv) && CheckBuyTP(tpv)){
                     Trade.SetDeviationInPoints(Sym.Spread()*3);
                     if(!Trade.Buy(lot,_Symbol,0,slv,tpv,"")){
                        return;
                     }
                  }
                  else{
                     Print(" Buy  ,    ");
                  }         
            }
            // 
            if(Signal<0){
               if(!Sym.RefreshRates())return;         
               if(!SolveLots(lot))return;
               slv=SolveSellSL(sl);
               tpv=SolveSellTP(tp);
                  if(CheckSellSL(slv) && CheckSellTP(tpv)){
                     Trade.SetDeviationInPoints(Sym.Spread()*3);
                     if(!Trade.Sell(lot,_Symbol,0,slv,tpv,"")){
                        return;
                     }
                  }
                  else{
                     Print(" Sell  ,    ");
                  }          
            }
      }            
      LastTime=ctm[0];
   }
}
//-------------------------------------------------------------------------+
bool Supervisor(double & Signal) {
   double BasicSig=0;
   if(!basicTradingSystem(BasicSig))return(false);
   Signal=0;
   if(pass==4){
      if(!Perceptron(output1,sh11,sh12,sh13,sh14,sh15,w11,w12,w13,w14) ||
         !Perceptron(output2,sh21,sh22,sh23,sh24,sh25,w21,w22,w23,w24) ||
         !Perceptron(output3,sh31,sh32,sh33,sh34,sh35,w31,w32,w33,w34)   
      )return(false);         
      if(output3>0){
         if(output2>0){
            sl=sl3;
            tp=tp3;
            Signal=1;
            return(true);
         }
       }
       else{
         if(output1<0){
            sl=sl2;
            tp=tp2;
            Signal=-1;
            return(true);
         }
      }
      Signal=BasicSig;
      return(true);
   }
   if(pass==3) {
      if(!Perceptron(output2,sh21,sh22,sh23,sh24,sh25,w21,w22,w23,w24))return(false);
      if(output2>0){
         sl=sl3;
         tp=tp3;
         Signal=1;
         return(true);
       } 
       else {
         Signal=BasicSig;
         return(true);
       }
   }
   if(pass==2){
      if(!Perceptron(output1,sh11,sh12,sh13,sh14,sh15,w11,w12,w13,w14))return(false);
      if(output1<0) {
         sl=sl2;
         tp=tp2;
         Signal=-1;
         return(true);
       } 
       else{
         Signal=BasicSig;
         return(true);
       }
   }   
   Signal=BasicSig;
   return(true);
}
   
double Perceptron(double & output,int sh1,int sh2,int sh3,int sh4,int sh5,double w1,double w2,double w3,double w4){
   double Csh1[1],Osh2[1],Osh3[1],Osh4[1],Osh5[1];
   if(CopyClose(_Symbol,PERIOD_CURRENT,sh1,1,Csh1)==-1 ||
      CopyClose(_Symbol,PERIOD_CURRENT,sh2,1,Osh2)==-1 ||
      CopyClose(_Symbol,PERIOD_CURRENT,sh3,1,Osh3)==-1 ||
      CopyClose(_Symbol,PERIOD_CURRENT,sh4,1,Osh4)==-1 ||
      CopyClose(_Symbol,PERIOD_CURRENT,sh5,1,Osh5)==-1
   )return(false);
   double a1=Csh1[0]-Osh2[0];
   double a2=Osh2[0]-Osh3[0];
   double a3=Osh3[0]-Osh4[0];
   double a4=Osh4[0]-Osh5[0];
   output=w1*a1+w2*a2+w3*a3+w4*a4;
   return(true);
}

bool basicTradingSystem(double & aSig){
   aSig=0;
   double cci0[1];
   if(CopyBuffer(CCIHandle,0,Shift,1,cci0)==-1)return(false);
   aSig=cci0[0];
   return(true);
}

//----   
   double Ma1[2],Ma2[2];
//----   
   static bool Recount=true;
   static bool BUY_Open=false,BUY_Close=false;
   static bool SELL_Open=false,SELL_Close=false;
   static datetime UpSignalTime,DnSignalTime;
   static CIsNewBar NB;

//+------------------------------------------------------------------+
//|      ,                    |
//+------------------------------------------------------------------+
bool Indicators(){

   return(true);
}

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
bool SignalOpenBuy(){

   return(false);
}

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
bool SignalOpenSell(){

   return(false);
}

//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
bool SignalCloseBuy(){

   return (false);
}

//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
bool SignalCloseSell(){

   return (false);
}

//+------------------------------------------------------------------+
//|      buy                               |
//+------------------------------------------------------------------+
double SolveBuySL(int StopLossPoints){
   if(StopLossPoints==0)return(0);
   return(Sym.NormalizePrice(Sym.Ask()-Sym.Point()*StopLossPoints));
}

//+------------------------------------------------------------------+
//|      buy                             |
//+------------------------------------------------------------------+
double SolveBuyTP(int TakeProfitPoints){
   if(TakeProfitPoints==0)return(0);
   return(Sym.NormalizePrice(Sym.Ask()+Sym.Point()*TakeProfitPoints));   
}

//+------------------------------------------------------------------+
//|      sell                               |
//+------------------------------------------------------------------+
double SolveSellSL(int StopLossPoints){
   if(StopLossPoints==0)return(0);
   return(Sym.NormalizePrice(Sym.Bid()+Sym.Point()*StopLossPoints));
}

//+------------------------------------------------------------------+
//|      sell                             |
//+------------------------------------------------------------------+
double SolveSellTP(int TakeProfitPoints){
   if(TakeProfitPoints==0)return(0);
   return(Sym.NormalizePrice(Sym.Bid()-Sym.Point()*TakeProfitPoints));   
}

//+------------------------------------------------------------------+
//|       buy                  |
//+------------------------------------------------------------------+
double BuyMSL(){
   return(Sym.NormalizePrice(Sym.Bid()-Sym.Point()*Sym.StopsLevel()));
}

//+------------------------------------------------------------------+
//|       buy                |
//+------------------------------------------------------------------+
double BuyMTP(){
   return(Sym.NormalizePrice(Sym.Ask()+Sym.Point()*Sym.StopsLevel()));
}

//+------------------------------------------------------------------+
//|       sell                 |
//+------------------------------------------------------------------+
double SellMSL(){
   return(Sym.NormalizePrice(Sym.Ask()+Sym.Point()*Sym.StopsLevel()));
}

//+------------------------------------------------------------------+
//|       sell               |
//+------------------------------------------------------------------+
double SellMTP(){
   return(Sym.NormalizePrice(Sym.Bid()-Sym.Point()*Sym.StopsLevel()));
}

//+------------------------------------------------------------------+
//|      buy                                 |
//+------------------------------------------------------------------+
bool CheckBuySL(double StopLossPrice){
   if(StopLossPrice==0)return(true);
   return(StopLossPrice<BuyMSL());
}

//+------------------------------------------------------------------+
//|      buy                               |
//+------------------------------------------------------------------+
bool CheckBuyTP(double TakeProfitPrice){
   if(TakeProfitPrice==0)return(true);
   return(TakeProfitPrice>BuyMTP());
}

//+------------------------------------------------------------------+
//|      sell                                 |
//+------------------------------------------------------------------+
bool CheckSellSL(double StopLossPrice){
   if(StopLossPrice==0)return(true);
   return(StopLossPrice>SellMSL());
}

//+------------------------------------------------------------------+
//|      sell                              |
//+------------------------------------------------------------------+
bool CheckSellTP(double TakeProfitPrice){
   if(TakeProfitPrice==0)return(true);
   return(TakeProfitPrice<SellMTP());
}

//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
bool SolveLots(double & aLots){
   aLots=lots;         
   return(true);
}
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
double fLotsNormalize(double aLots){
   aLots-=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
   aLots/=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP);
   aLots=MathRound(aLots);
   aLots*=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP);
   aLots+=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
   aLots=NormalizeDouble(aLots,2);
   aLots=MathMin(aLots,SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX));
   aLots=MathMax(aLots,SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN));   
   return(aLots);
}
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
void fSimpleTrailing(){
   if(Trailing<=0){
      return;
   }         
   if(!Pos.Select(_Symbol)){
      return;
   }         
   if(!Sym.RefreshRates()){
      return;  
   }   
   double nsl,tmsl,psl;  
   switch(Pos.PositionType()){
      case POSITION_TYPE_BUY:
         nsl=Sym.NormalizePrice(Sym.Bid()-_Point*Trailing);
            if(nsl>=Sym.NormalizePrice(Pos.PriceOpen())){
               if(nsl>Sym.NormalizePrice(Pos.StopLoss())){
                  tmsl=Sym.NormalizePrice(Sym.Bid()-_Point*Sym.StopsLevel());
                     if(nsl<tmsl){
                        Trade.PositionModify(_Symbol,nsl,Pos.TakeProfit());
                     }
               }
            }
      break;
      case POSITION_TYPE_SELL:
         nsl=Sym.NormalizePrice(Sym.Ask()+_Point*Trailing);
            if(nsl<=Sym.NormalizePrice(Pos.PriceOpen())){
               psl=Sym.NormalizePrice(Pos.StopLoss());
                  if(nsl<psl || psl==0){
                     tmsl=Sym.NormalizePrice(Sym.Ask()+_Point*Sym.StopsLevel());
                        if(nsl>tmsl){
                           Trade.PositionModify(_Symbol,nsl,Pos.TakeProfit());
                        }
                  }
            }      
      break;
   }
}

//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
void fSimpleBreakEven(){
   if(BreakEven<=0){
      return;
   }         
   if(!Pos.Select(_Symbol)){
      return;
   }   
   if(!Sym.RefreshRates()){
      return;  
   }            
   double op=Sym.NormalizePrice(Pos.PriceOpen());
   double sl=Sym.NormalizePrice(Pos.StopLoss());
   double nsl;  
   switch(Pos.PositionType()){
      case POSITION_TYPE_BUY:
         if(sl<op){
            nsl=Sym.NormalizePrice(Sym.Bid()-_Point*BreakEven); 
               if(nsl>=op){
                  if(op<Sym.NormalizePrice(Sym.Bid()-_Point*Sym.StopsLevel())){
                     Trade.PositionModify(_Symbol,op,Sym.NormalizePrice(Pos.TakeProfit()));
                  }
               }   
         }
      break;
      case POSITION_TYPE_SELL:
         if(sl>op || sl==0){
            nsl=Sym.NormalizePrice(Sym.Ask()+_Point*BreakEven); 
               if(nsl<=op){
                  if(op>Sym.NormalizePrice(Sym.Ask()+_Point*Sym.StopsLevel())){
                     Trade.PositionModify(_Symbol,op,Sym.NormalizePrice(Pos.TakeProfit()));
                  }
               }   
         }    
      break;
   }
}
//---------------------------------------------------------------------------+